#pragma once

#include "global.h"
#include "Texture.h"
#include "GraphicsTownUI.h"

namespace configure {
	extern int numTrees, numBirds, numGraves;
}

namespace fireworks_config {
	extern double speedMult, grav, pSize, terminal, decay, rocketBurstSpeed, rocketTime, maxRockets, rocketSpeed;
	extern int rocketTrail, burstCount;
}

namespace bird_config {
	const int viewAngle = 140;
	const int viewDepth = 6000; // compared to square of distance
	const int avoidDepth = 2000;

	extern float meMult, avoidMult, crowdMult, copyMult;
	extern float minz, maxz;

}

namespace tree_config {
	namespace trees {
		extern double medScale, maxScaleChange, scalePower;
		extern int count;
	}
	namespace limbs {
		extern double startLength, lengthMin, lengthMax, downMin, downMax, angleVariance, ratio, endLength, branchMin;
		extern int maxDepth, count, split;
	}

	namespace bases {
		extern double startLength, lengthMin, lengthMax, downMin, downMax, angleVariance, ratio, endLength, branchMin;
		extern int maxDepth, count, split;
	}

}

class config
{
private:
	config() : reset(false), displayLists(true) {}
	config(const config&) {}
	const config& operator=(const config&) {}
public:
	bool reset;
	bool displayLists;
	GraphicsTownUI* ui;
	static config cfg;
	static config& instance() {return cfg;}
	bool depthSort() {return (!ui || ui->lgTex->value());}
	bool widowlegs() {return (!ui || ui->widow->value());}
	void setup();

	void texture(std::string s) {fetchTexture(s.c_str())->bind();}

};

extern config& cfg;
