#include "depthSorter.h"
#include "drawingState.h"
#include <map>

depthSorter::depthSorter(void)
{
}

depthSorter::~depthSorter(void)
{
}

void depthSorter::drawAfter(DrawingState * st) {
	Matrix cam;
	st->camera->getCamera(cam);
	invertMatrix(cam);

	float cx = cam[3][0], cz = cam[3][2];
	map<double, special*> order;
	for (vector<special*>::iterator i = objects.begin(); i != objects.end(); ++i)
		order.insert(pair<double, special*>(((*i)->xv() - cx) * ((*i)->xv() - cx) + ((*i)->zv() - cz) * ((*i)->zv() - cz), *i));

	if (cfg.depthSort()) {
		for (map<double, special*>::reverse_iterator iter = order.rbegin(); iter != order.rend(); iter++)
		{
			glPushMatrix();
			glBindTexture(GL_TEXTURE_2D,0);
			iter->second->drawSpecial(st);
			glPopMatrix();
		}
	}
	else {
		for (vector<special*>::reverse_iterator i = objects.rbegin(); i != objects.rend(); i++)
		{
			glPushMatrix();
			glBindTexture(GL_TEXTURE_2D,0);
			(*i)->drawSpecial(st);
			glPopMatrix();
		}

	}
}