#include "grave.h"
#include "global.h"

Texture* grave::textures[6];
Texture* mod[12];
int numTextures = 5;
int numMods = 12;
int grave::list = 0;
bool made = false;

grave::grave(float a, float b, float c, float d, float e, float f, float g) : x(a), y(b), z(c), rot(d), sx(e), sy(f), sz(g)
{
	texId1 = irand(0, numTextures - 1);
	texId2 = irand(0, numMods - 1);
	texId3 = irand(0, numMods - 1);
}

grave::~grave(void)
{
}



void multitex() {
	

	
	
}

void drawGrave() {
	triple points[20];
	triple tex[20];

	glColor3f(1, 1, 1);

	points[0] = triple(-3, 0, 1);
	tex[0] = triple(0, 0, 0);
	points[1] = triple(3, 0, 1);
	tex[1] = triple(1, 0, 0);
	for (int i = 0; i < 8; ++i) {
		float val = i * 3.14159 / 7;
		points[2 + i] = triple(3 * cos(val), 6 + 3 * sin(val), 1);
		tex[2 + i] = triple(0.5 + 0.5 * cos(val), 0.3 + 0.1 * sin(val), 0);
	}
	for (int i = 10; i < 20; i++) {
		points[i] = points[i - 10] - triple(0, 0, 2);
		tex[i] = tex[i - 10];
	}
	
	glBegin(GL_POLYGON);
	glNormal3f(0, 0, 1);
	for (int i = 0; i < 10; ++i) {
		glMultiTexCoord2f(GL_TEXTURE0, tex[i].x, tex[i].y);
		glMultiTexCoord2f(GL_TEXTURE1, tex[i].x, tex[i].y);
		glMultiTexCoord2f(GL_TEXTURE2, tex[i].x, tex[i].y);
		points[i].draw();
	}
	glEnd();
	glBegin(GL_POLYGON);
	glNormal3f(0, 0, -1);
	for (int i = 19; i >= 10; --i) {
		glMultiTexCoord2f(GL_TEXTURE0, tex[i].x, tex[i].y);
		glMultiTexCoord2f(GL_TEXTURE1, tex[i].x, tex[i].y);
		glMultiTexCoord2f(GL_TEXTURE2, tex[i].x, tex[i].y);
		points[i].draw();
	}
	glEnd();

	glBegin(GL_QUAD_STRIP);
	for (int i = 1; i < 10; ++i) {
		glMultiTexCoord2f(GL_TEXTURE0, i * 0.1, 0.45);
		glMultiTexCoord2f(GL_TEXTURE1, i * 0.1, 0.45);
		glMultiTexCoord2f(GL_TEXTURE2, i * 0.1, 0.45);
		points[i].draw();
		glMultiTexCoord2f(GL_TEXTURE0, i * 0.1, 0.55);
		glMultiTexCoord2f(GL_TEXTURE1, i * 0.1, 0.55);
		glMultiTexCoord2f(GL_TEXTURE2, i * 0.1, 0.55);
		points[i + 10].draw();
	}

	glTexCoord2f(1, 0.4);
	points[0].draw();
	glTexCoord2f(1, 0.6);
	points[10].draw();
	glEnd();

}

void grave::draw(DrawingState*) {
	if (!made) init();

	int texName0 = textures[texId1]->texName;
	int texName1 = mod[texId2]->texName;
	int texName2 = mod[texId3]->texName;
	
	glPushAttrib(GL_ENABLE_BIT | GL_TEXTURE_BIT);

	glActiveTexture( GL_TEXTURE0 );
	glEnable( GL_TEXTURE_2D );
	glBindTexture(GL_TEXTURE_2D, texName0);
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	glActiveTexture( GL_TEXTURE1 );
	glEnable( GL_TEXTURE_2D );
	glBindTexture(GL_TEXTURE_2D, texName1);
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	glActiveTexture( GL_TEXTURE2 );
	glEnable( GL_TEXTURE_2D );
	glBindTexture(GL_TEXTURE_2D, texName2);
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	glTranslatef(x, y, z);
	glScalef(sx, sy, sz);
	glRotatef(rot, 0, 1, 0);
	glCallList(list);
	//drawGrave();
	glPopAttrib();
}




void grave::init() {
	textures[0] = fetchTexture("grave0.jpg");
	textures[1] = fetchTexture("grave1.jpg");
	textures[2] = fetchTexture("grave2.jpg");
	textures[3] = fetchTexture("grave3.jpg");
	textures[4] = fetchTexture("grave4.jpg");

	mod[0] = fetchTexture("gravemod0.jpg");
	mod[1] = fetchTexture("gravemod1.jpg");
	mod[2] = fetchTexture("gravemod2.jpg");
	mod[3] = fetchTexture("gravemod3.jpg");
	mod[4] = fetchTexture("gravemod4.jpg");
	mod[5] = fetchTexture("gravemod5.jpg");
	mod[6] = fetchTexture("gravemod6.jpg");
	mod[7] = fetchTexture("gravemod7.jpg");
	mod[8] = fetchTexture("gravemod8.jpg");
	mod[9] = fetchTexture("gravemod9.jpg");
	mod[10] = fetchTexture("gravemod10.jpg");
	mod[11] = fetchTexture("gravemod11.jpg");

	list = glGenLists(1);
	glNewList(list, GL_COMPILE);
	drawGrave();
	glEndList();

	made = true;
}

